<?php
c_include('forms/formField');
e_include('ext_informes/class/informe');
/**
 * Form Field class for the Mideas Framework.
 *
 * @package		Mideas.Framework
 * @subpackage	Form
 * @since		1.6
 */
class FormFieldCampositemextensionlist extends FormField
{
	/**
	 * The producto field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'campositemextensionlist';
	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	public function getInput($valor=null)
	{
		if ($_GET['extension'] != 'ext_informes' && ($_GET['vista'] != 'editar' || $_GET['vista'] != 'nuevo'))
			return false;
			
		// Initialize variables.
		$html = array();
		$attr = '';
		// Initialize some field attributes.
		$attr .= $this->element['class'] ? ' class="select2 '.(string) $this->element['class'].'"' : ' class="select2"';
		// To avoid user's confusion, readonly="true" should imply disabled="true".
		if ( (string) $this->element['readonly'] == 'true' || (string) $this->element['disabled'] == 'true') {
			$attr .= ' disabled="disabled"';
		}
		$attr .= $this->element['size'] ? ' size="'.(int) $this->element['size'].'"' : '';
		$attr .= $this->element['multicheck'] != 'false' ? ' multiple="multiple"' : '';
		// Initialize JavaScript field attributes.
		$attr .= $this->element['onchange'] ? ' onchange="'.(string) $this->element['onchange'].'"' : '';
		
		$output = '';
		if ($_GET['vista'] == 'nuevo'){
			$output .= '<div class="alert alert-info">'.__('Debes guardar el informe para seleccionar los campos del item a mostrar en el informe').'</div>';
		} else {
			$output .= $this->getTablaLineas($valor, $attr);
		}
		
		return $output;
	}
	
	function getTablaLineas($valor, $attr){
		$informe = new Informe();
		if (!empty($_GET['id'])){			
			$informe->setid($_GET['id']);
			$informe = $informe->BuscarId();
		} else {
			return '<div class="alert alert-danger">'.__('No se encuentra el informe').'</div>';
		}
		
		$params_informe = Helpers::toArray(json_decode($informe->params));
		
		$exp_ext = explode(":",$params_informe['dataitem']);
		if (!is_array($exp_ext) || sizeof($exp_ext) != 2)
			return '<div class="alert alert-danger">'.__('Matriz de datos incorrecta').'</div>';
		
		$obj_ext = Helpers::getExtensionsClasses('item', $exp_ext[0]);
		
		if (!is_array($obj_ext[$exp_ext[0]]) || $obj_ext[$exp_ext[0]]['vista'] != $exp_ext[1]){
			return '<div class="alert alert-danger">'.__('Datos incorrectos').'</div>';
		}
		
		$obj_item = $obj_ext[$exp_ext[0]];
		
		if (!class_exists($obj_item['class'])){
			$path_class = 'extensions/' . $exp_ext[0] . '/class/' . $obj_item['file_class'];
			e_include($path_class);
		}
		
		if (!class_exists($obj_item['class'])){
			return '<div class="alert alert-danger">'.__('No se encuentra la clase de la extensión').'</div>';
		}
		
		$obj_class_item_name = $obj_item['class'];
		$obj_class_item = new $obj_class_item_name();
		
		$campos_defecto = $obj_class_item->get('all_vars');
		
		$campos_defecto[] = "personalizado";
		
		$opts_campos = '';
		foreach ($campos_defecto as $camp){
			$opts_campos .= '<option value="'.$camp.'">'.ucfirst($camp).'</option>';
		}
		
		$html = '';
		
		if (!empty($informe)){
			
			$html .= '<table class="table table-striped" id="tabla_campos_informe">';
			$html .= '<thead><tr>';
			$html .= '<th>'.__('Borrar').'</th>';
			$html .= '<th>'.__('Etiqueta').'</th>';
			$html .= '<th>'.__('Campo').'</th>';
			$html .= '<th>'.__('Sub-Campo').'</th>';
			$html .= '<th>'.__('Tipo').'</th>';
			$html .= '</tr></thead>';
			
			$html .= '<tbody>';
			if (is_array($valor) && sizeof($valor) > 0){
				foreach ($valor as $klinea=>$linea){
					$html .= '<tr class="linea_campo_informe" id="linea_campo_informe_'.$klinea.'">
				<td width="5%" align="center"><a href="#" data-id="#linea_campo_informe_'.$klinea.'" class="confirm-delete-linea-campo-informe btn btn-default btn-sm"><i class="fa fa-trash-o"></i></a></td>
				<td width="25%"><input type="text" class="form-control" name="'.$this->name.'['.$klinea.'][etiqueta]" value="'.$linea['etiqueta'].'" /></td>
				<td><select class="select2" name="'.$this->name.'['.$klinea.'][campo]">';
				
					foreach ($campos_defecto as $camp){
						$selected_campo = '';
						if ($linea['campo'] == $camp){
							$selected_campo = ' selected="selected"';
						}
						$html .= '<option value="'.$camp.'"'.$selected_campo.'>'.ucfirst($camp).'</option>';
					}
				
				$html .= '</select></td>
				<td width="20%"><input type="text" class="form-control" name="'.$this->name.'['.$klinea.'][subcampo]" value="'.$linea['subcampo'].'" /></td>
				<td width="15%"><input type="text" class="form-control cant_linea" name="'.$this->name.'['.$klinea.'][tipo]" value="'.$linea['tipo'].'" /></td>
				</tr>';                  
				}
				
				
			}
				
				$GLOBALS['AppDoc']->AddScriptDeclaration('
				$(window).load(function(){
					var fixHelperModified = function(e, tr) {
						var $originals = tr.children();
						var $helper = tr.clone();
						$helper.children().each(function(index)
						{
						  $(this).width($originals.eq(index).width())
						});
						return $helper;
					};
				
					$("table#tabla_campos_informe tbody").sortable({
						helper: fixHelperModified,
						update : function () { 
							  Utilidades.Notificar("'.__('Guarda el informe para confirmar el nuevo orden de los campos.').'");		  
							} 
					}).disableSelection();
				});
				
				$(document).ready(function(){
					
					$(".add-linea-campo-informe").click(function(){
						var time_now = new Date().getTime();
						
						$("#tabla_campos_informe tbody").append(\'<tr class="linea_campo_informe" id="linea_campo_informe_\'+time_now+\'"><td width="5%" align="center"><a href="#" data-id="#linea_campo_informe_\'+time_now+\'" class="confirm-delete-linea-campo-informe btn btn-default btn-sm"><i class="fa fa-trash-o"></i></a></td><td width="25%"><input type="text" class="form-control" name="'.$this->name.'[\'+time_now+\'][etiqueta]" value="" /></td><td><select class="select2 select_campo_informe" name="'.$this->name.'[\'+time_now+\'][campo]">'.$opts_campos.'</select></td><td width="20%"><input type="text" class="form-control" name="'.$this->name.'[\'+time_now+\'][subcampo]" /></td><td width="15%"><input type="text" class="form-control cant_linea" name="'.$this->name.'[\'+time_now+\'][tipo]" /></td></tr>\');
						
						$("select.select_campo_informe").select2();
					});
				});
				');
			
			$html .= '</tbody></table>';
			
			$html .= '<div class="clearfix pull-left"><a class="btn btn-sm btn-primary add-linea-campo-informe" href="javascript:;" ><i class="fa fa-plus icon-white"> </i> '.__('Añadir campo').'</a></div>';
			
								
				$html .= '<div id="modal-delete-campo-informe" class="modal fade">
				<div class="modal-dialog">
				<div class="modal-content">
              <div class="modal-header">
                <button onclick="$(\'#modal-delete-campo-informe\').modal(\'hide\');return false;" class="close">&times;</button>
                <h3>'.__('Borrar Campo de Informe').'</h3>
              </div>
              <div class="modal-body">
                <p>'.__('Va a eliminar permanentemente un campo del informe. Este proceso es irreversible.').'</p>
                <p>'.__('¿Quiere continuar con la eliminación del campo?').'</p>
              </div>
              <div class="modal-footer"> <a href="javascript:;" class="btn btn-danger" id="del-campo-informe-btn">'.__('Sí').'</a> <a href="javascript:$(\'#modal-delete-campo-informe\').modal(\'hide\')" class="btn secondary">'.__("No").'</a> </div>
            </div>
			</div>
			</div>';
				
				$GLOBALS['AppDoc']->AddScriptDeclaration('//<![CDATA[ 
$(window).load(function(){
$("#del-campo-informe-btn").live("click", function() {
	var this_el = $(this);
	
	var id = $("#modal-delete-campo-informe").data("id");
			
	$(id).remove();
	
	$("#modal-delete-campo-informe").modal("hide");
});
$(".confirm-delete-linea-campo-informe").live("click", function(e) {
    e.preventDefault();
    
    var id = $(this).data("id");
    $("#modal-delete-campo-informe").data("id", id).modal("show");
});
});//]]>');
			
			
		}
		
		return $html;
	}
	
	
}
