<?php
defined('CONF_URL_APP') or die;
class Informe extends ItemModel
{
	protected $dbt_const = "DBT_INFORMES";
	protected $dbt = "informes";
	
	protected $ext_folder = "ext_informes";
	protected $ext_vista_categoria = "informe_category";
	protected $ext_vista_item = "informe";
	
	protected $ext_item_class = "Informe";
	protected $ext_categoria_class = "InformeCategory";
	protected $ext_item_campoextra_class = "InformeCampoExtra";
	
	protected $all_vars = array("id","titulo","alias","contenido","fecha","fecha_publicacion","estado","imagen_destacada","categorias","creador","creador_alias","propietario","params","tags","idioma","lugar","direccion","codigo_postal","localidad","provincia","pais","latitud","longitud","location","acceso","id_original");
	
	protected $idx_vars = array("id");
	protected $update_vars = array("titulo","alias","contenido","fecha_publicacion","estado","imagen_destacada","categorias","creador","creador_alias","propietario","params","tags","idioma","lugar","direccion","codigo_postal","localidad","provincia","pais","latitud","longitud","location","acceso","id_original");
	
	protected $campos_multilang = array("titulo","alias","contenido","lugar");
	protected $campos_array = array("params","categorias");
	
	var $item_model, $campos_defecto_item = array(), $campos_array_item = array(), $campos_multilang_item = array(), $columnas_informe = array(), $orden_informe = "id", $direccion_orden_informe = "DESC", $filtro_informe_sql = "", $resultados_informe = array();
	
	function __construct(){
		parent::__construct();
	}
	
	function includes(){
		c_include('loc/region','loc/provincia','loc/localidad','loc/pais');
		e_include('ext_informes/class/informeCategory');
	}
	
	function generarInforme(){
		$params_informe = Helpers::toArray(json_decode($this->params));

		$this->columnas_informe = $params_informe['fieldsdataitem'];
		
		$exp_ext = explode(":",$params_informe['dataitem']);
		if (!is_array($exp_ext) || sizeof($exp_ext) != 2)
			return '<div class="alert alert-danger">'.__('Matriz de datos incorrecta').'</div>';
		
		$obj_ext = Helpers::getExtensionsClasses('item', $exp_ext[0]);
		
		if (!is_array($obj_ext[$exp_ext[0]]) || $obj_ext[$exp_ext[0]]['vista'] != $exp_ext[1]){
			return '<div class="alert alert-danger">'.__('Datos incorrectos').'</div>';
		}
		
		$obj_item = $obj_ext[$exp_ext[0]];
		
		if (!class_exists($obj_item['class'])){
			$path_class = 'extensions/' . $exp_ext[0] . '/class/' . $obj_item['file_class'];
			e_include($path_class);
		}
		
		if (!class_exists($obj_item['class'])){
			return '<div class="alert alert-danger">'.__('No se encuentra la clase de la extensión').'</div>';
		}
		
		$obj_class_item_name = $obj_item['class'];
		$this->item_model = new $obj_class_item_name();
		
		$this->campos_defecto_item = $this->item_model->get('all_vars');
		$this->campos_array_item = $this->item_model->get('campos_array');
		$this->campos_multilang_item = $this->item_model->get('campos_multilang');
		
		if (!empty($_GET['orden_informe'])){
			$this->orden_informe = $_GET['orden_informe'];
		}
		if (!empty($_GET['direccion_orden_informe'])){
			$this->direccion_orden_informe = $_GET['direccion_orden_informe'];
		}
		$filtro_informe = array();
		if (!empty($_GET['fecha_inicio'])){
			$filtro_informe[] = "fecha >= '".$_GET['fecha_inicio']." 00:00:00'";
		}
		if (!empty($_GET['fecha_fin'])){
			$filtro_informe[] = "fecha <= '".$_GET['fecha_fin']." 23:59:59'";
		}
		
		$this->filtro_informe_sql = implode(" AND ", $filtro_informe);
		
		$this->resultados_informe = $this->item_model->Listar($this->filtro_informe_sql, $this->orden_informe, $this->direccion_orden_informe);
		
		return true;
	}
	
	function printValorCampo($campo, $valor){
		if (empty($campo['campo']) || !is_object($valor) || !is_object($this->item_model)){
			return '';
		}
		
		$campo_sel = $campo['campo'];
		$subcampo = $campo['subcampo'];
		$tipo = $campo['tipo'];
		
		$tipo_obj = get_class($this->item_model);
		
		if ($tipo_obj != get_class($valor))
			return '';
			
		$valor_asignado = "";
			
		if (property_exists($valor, $campo_sel)){
			if (!empty($subcampo)){
				if (!is_array($valor->$campo_sel) && in_array($campo_sel,$this->campos_array_item)){
					$p = Helpers::toArray(json_decode($valor->$campo_sel));
				} elseif (in_array($campo_sel,$this->campos_multilang_item)) {
					$p = Helpers::toArray(json_decode($valor->$campo_sel));
				} else {
					$p = $valor->$campo_sel;
				}
				if (isset($p[$subcampo])){
					$valor_asignado = $p[$subcampo];
				}
			} else {
				if (in_array($campo_sel,$this->campos_multilang_item)) {
					$valor_asignado = SistemaIdioma::Imprimir($valor->$campo_sel);
				} else {
					$valor_asignado = $valor->$campo_sel;
				}
			}
		} elseif ($campo_sel == 'personalizado' && !empty($subcampo)){
			if (property_exists($valor, $subcampo)){
				if (in_array($subcampo,$this->campos_multilang_item)) {
					$valor_asignado = SistemaIdioma::Imprimir($valor->$subcampo);
				} else {
					$valor_asignado = $valor->$subcampo;
				}
			} else {
				$cont = str_replace("##ID##", $valor->id, $subcampo);
				
				if (is_object($GLOBALS['shortcodes'])){
					$valor_asignado = $GLOBALS['shortcodes']->do_shortcode_all($cont);
				}
			}
		}
		
		switch ($tipo){
			case 'int':
				return number_format($valor_asignado, 0, ',', '.');
				break;
			case 'date':
				return strftime(SistemaIdioma::formatoFecha('sistema'), strtotime($valor_asignado));
				break;
			case 'short_date':
				return strftime(SistemaIdioma::formatoFecha('corta'), strtotime($valor_asignado));
				break;
			case 'full_date':
				return strftime(SistemaIdioma::formatoFecha('larga'), strtotime($valor_asignado));
				break;
			case 'currency':
				$importe_valor = Helpers::Importe($valor_asignado);
				e_include('ext_shop/class/helper');
				if (class_exists('ShopHelper')){
					$importe_valor .= ' ' . ShopHelper::get_shop_moneda_simbolo();
				}
				return $importe_valor;
				break;
			case 'bool':
				if ($valor_asignado == '0'){
					return '<i class="fa fa-times"></i>';
				} elseif ($valor_asignado == '1'){
					return '<i class="fa fa-check"></i>';
				} else {
					return $valor_asignado;
				}
				break;
			case 'string':
			default:
				return $valor_asignado;
				break;
		}
	}
}
?>